apiVersion: v1
kind: Namespace
metadata:
  name: hw-02
---
apiVersion: apps/v1
kind: ReplicaSet
metadata:
  name: nginx-server
  namespace: hw-02
  labels:
    app: nginx-server    
spec:  
  replicas: 3
  selector:
    matchLabels:
      app: nginx-server
  template:
    metadata:
      labels:
        app: nginx-server
    spec:
      topologySpreadConstraints:
      - maxSkew: 1
        topologyKey: kubernetes.io/hostname
        whenUnsatisfiable: DoNotSchedule
        labelSelector:
          matchLabels:
            app: nginx-server
      containers:
      - name: nginx-server
        image: nginx:1.19.4
        resources:
          limits:
            cpu: "100m"
            memory: "256Mi"
          requests:
            cpu: "100m"
            memory: "256Mi"
        ports:
        - containerPort: 80

---
apiVersion: v1
kind: Service
metadata:
  name: nginx-server
  namespace: hw-02
  labels:
    app: nginx-server
spec:
  type: NodePort #Abriendo un puerto especifico de la VM
  ports:
  - port: 80 #Pod Port
    targetPort: 80 #Container Port
    nodePort: 31234
    protocol: TCP
    name: http  
  selector:
    app: nginx-server